package com.hammingweight.hammockexamples.example3;

public class StreamCipher {

	private PseudoRandomByteStream encStream, decStream;

	public StreamCipher(PseudoRandomByteStream encStream,
			PseudoRandomByteStream decStream) {
		this.encStream = encStream;
		this.decStream = decStream;
	}

	public byte[] encrypt(byte[] plaintext) {
		byte[] rnd = new byte[plaintext.length];
		this.encStream.generateBytes(rnd);
		for (int i = 0; i < rnd.length; i++) {
			rnd[i] ^= plaintext[i];
		}
		return rnd;
	}

	public byte[] decrypt(byte[] ciphertext) {
		byte[] rnd = new byte[ciphertext.length];
		this.decStream.generateBytes(rnd);
		for (int i = 0; i < rnd.length; i++) {
			rnd[i] ^= ciphertext[i];
		}
		return rnd;
	}
}
