package com.hammingweight.hammockexamples.example4;

import java.io.DataInput;
import java.io.DataInputStream;
import java.io.DataOutput;
import java.io.DataOutputStream;
import java.io.IOException;

import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;


public class HttpConnectionFactory implements ConnectionFactory {

	private String host;

	private HttpConnection httpConn;

	private DataOutputStream dos;

	private DataInputStream dis;

	public HttpConnectionFactory(String host) {
		this.host = host;
	}

	public void closeConnections() {
		if (this.dos != null) {
			try {
				this.dos.close();
			} catch (IOException e) {
			}
		}

		if (this.dis != null) {
			try {
				this.dis.close();
			} catch (IOException e) {
			}
		}

		if (this.httpConn != null) {
			try {
				this.httpConn.close();
			} catch (IOException e) {
			}
		}

		this.dos = null;
		this.dis = null;
		this.httpConn = null;
	}

	public DataInput getInputConnection() throws IOException {
		this.dis = this.httpConn.openDataInputStream();
		return this.dis;
	}

	public DataOutput getOutputConnection() throws IOException {
		this.dos = this.httpConn.openDataOutputStream();
		return this.dos;
	}

	protected void openConnections(HttpConnection httpConn) throws IOException {
		this.httpConn = httpConn;
		this.httpConn.setRequestMethod(HttpConnection.GET);
	}

	public void openConnections(String relativePath) throws IOException {
		openConnections((HttpConnection) Connector.open("http://" + this.host
				+ "/" + relativePath));
	}

}
