package com.hammingweight.hammockexamples.example2;

import java.util.Hashtable;

import jmunit.framework.cldc10.TestCase;

import com.hammingweight.hammock.Hammock;
import com.hammingweight.hammock.mocks.util.MockRandom;
import com.hammingweight.hammockexamples.example2.Person;
import com.hammingweight.hammockexamples.example2.PersonDao;
import com.hammingweight.hammockexamples.mocks.MockPersistence;

public class PersonDaoTest extends TestCase {

	// The OUT.
	private PersonDao personDao;

	// The handler and mock(s)
	private Hammock hammock;
	private MockPersistence mockPersistence;
	private MockRandom mockRandom;

	public void setUp() {
		this.hammock = new Hammock();
		this.mockPersistence = new MockPersistence(this.hammock);
		this.mockRandom = new MockRandom(this.hammock);
		this.personDao = new PersonDao();
		this.personDao.setPersistence(this.mockPersistence);
		this.personDao.setRandom(this.mockRandom);
	}

	public void testPersist() {
		// Expectations.
		// The Random object should be asked to generate a random ID.
		// Our random value is -42.
		this.hammock.setExpectation(MockRandom.MTHD_NEXT_INT).setReturnValue(
				new Integer(-42)).setInvocationCount(1, 3);
		// A Hashtable with the first and last names should be persisted.
		Hashtable h = new Hashtable();
		h.put("fname", "Carl");
		h.put("lname", "Meijer");
		this.hammock.setExpectation(
				MockPersistence.MTHD_PERSIST_$_CLASS_INT_HASHTABLE,
				new Object[] { new Person("", "").getClass(), new Integer(-42),
						h }).setDelay(500).setArgumentMatcher(2,
				new HashtableMatcher());

		// Exercise.
		this.personDao.persist(new Person("Carl", "Meijer"));

		// Verify.
		this.hammock.verify();
	}

	public PersonDaoTest() {
		super(1, "PersonDaoTest");
	}

	public void test(int testNum) throws Throwable {
		switch (testNum) {
		case 0:
			testPersist();
			break;

		default:
			fail("No such test.");
		}
	}

}
