package com.hammingweight.hammockexamples.example6;

import java.util.Vector;

import jmunit.framework.cldc10.TestCase;

import com.hammingweight.hammock.Hamspy;
import com.hammingweight.hammock.mocks.util.MockVector;

public class ConcreteSpyTest extends TestCase {

	public void testDelegateToParent() {
		Vector spyVector = new MockVector(new Hamspy());
		spyVector.addElement("foo");
		assertEquals(1, spyVector.size());
		assertEquals("foo", spyVector.elementAt(0));
	}

	public void testReturnDefaultValues() {
		Hamspy hamspy = new Hamspy(true);
		Vector spyVector = new MockVector(hamspy);
		hamspy.setStubExpectation(MockVector.MTHD_ELEMENT_AT_$_INT,
				new Object[] { new Integer(100) }).setReturnValue("bar");
		spyVector.addElement("foo");
		assertEquals(0, spyVector.size());
		assertNull(spyVector.elementAt(0));
		assertEquals("bar", spyVector.elementAt(100));
	}

	public ConcreteSpyTest() {
		super(2, "ConcreteSpyTest");
	}

	public void test(int testNum) throws Throwable {
		switch (testNum) {
		case 0:
			testDelegateToParent();
			break;

		case 1:
			testReturnDefaultValues();
			break;

		default:
			fail("No such test.");
		}
	}

}
