//
// This mock object source code was generated by HammockMaker.
//
package com.hammingweight.hammock.mocks.util;

import com.hammingweight.hammock.*;

public class MockRandom extends java.util.Random implements IMockObject {

	private IInvocationHandler handler;

	// Methods defined in IMockObject.
	public final void setInvocationHandler(IInvocationHandler handler) {
		if (handler == null) {
			throw new NullPointerException();
		}

		this.handler = handler;
	}

	public final IInvocationHandler getInvocationHandler() {
		if (this.handler == null) {
			setInvocationHandler(new Hamspy());
		}
		return this.handler;
	}

	// Overridden methods.
	public static final MockMethod MTHD_NEXT_DOUBLE = new MockMethod(
			MockRandom.class, "MTHD_NEXT_DOUBLE", new Class[] {},
			new Class[] {}, Double.class, false);

	public double nextDouble() {
		try {
			Object[] args = new Object[0];
			MethodInvocation mi = new MethodInvocation(MTHD_NEXT_DOUBLE, this,
					args);
			getInvocationHandler().invoke(mi);
			if (mi.isEvaluated()) {
				Object retVal = mi.getReturnValue();
				AMockObject.assertReturnNotNull(MTHD_NEXT_DOUBLE, retVal);
				return ((Double) retVal).doubleValue();
			}
		} catch (Throwable t) {
			if (t instanceof java.lang.Error) {
				throw (java.lang.Error) t;
			}
			if (t instanceof java.lang.RuntimeException) {
				throw (java.lang.RuntimeException) t;
			}
			throw new HammockException(t);
		}
		return super.nextDouble();
	}

	public static final MockMethod MTHD_NEXT_FLOAT = new MockMethod(
			MockRandom.class, "MTHD_NEXT_FLOAT", new Class[] {},
			new Class[] {}, Float.class, false);

	public float nextFloat() {
		try {
			Object[] args = new Object[0];
			MethodInvocation mi = new MethodInvocation(MTHD_NEXT_FLOAT, this,
					args);
			getInvocationHandler().invoke(mi);
			if (mi.isEvaluated()) {
				Object retVal = mi.getReturnValue();
				AMockObject.assertReturnNotNull(MTHD_NEXT_FLOAT, retVal);
				return ((Float) retVal).floatValue();
			}
		} catch (Throwable t) {
			if (t instanceof java.lang.Error) {
				throw (java.lang.Error) t;
			}
			if (t instanceof java.lang.RuntimeException) {
				throw (java.lang.RuntimeException) t;
			}
			throw new HammockException(t);
		}
		return super.nextFloat();
	}

	public static final MockMethod MTHD_NEXT_$_INT = new MockMethod(
			MockRandom.class, "MTHD_NEXT_$_INT", new Class[] { Integer.class },
			new Class[] {}, Integer.class, false);

	public int next(int arg0) {
		try {
			Object[] args = new Object[1];
			args[0] = new Integer(arg0);
			MethodInvocation mi = new MethodInvocation(MTHD_NEXT_$_INT, this,
					args);
			getInvocationHandler().invoke(mi);
			if (mi.isEvaluated()) {
				Object retVal = mi.getReturnValue();
				AMockObject.assertReturnNotNull(MTHD_NEXT_$_INT, retVal);
				return ((Integer) retVal).intValue();
			}
		} catch (Throwable t) {
			if (t instanceof java.lang.Error) {
				throw (java.lang.Error) t;
			}
			if (t instanceof java.lang.RuntimeException) {
				throw (java.lang.RuntimeException) t;
			}
			throw new HammockException(t);
		}
		return super.next(arg0);
	}

	public static final MockMethod MTHD_NEXT_INT = new MockMethod(
			MockRandom.class, "MTHD_NEXT_INT", new Class[] {}, new Class[] {},
			Integer.class, false);

	public int nextInt() {
		try {
			Object[] args = new Object[0];
			MethodInvocation mi = new MethodInvocation(MTHD_NEXT_INT, this,
					args);
			getInvocationHandler().invoke(mi);
			if (mi.isEvaluated()) {
				Object retVal = mi.getReturnValue();
				AMockObject.assertReturnNotNull(MTHD_NEXT_INT, retVal);
				return ((Integer) retVal).intValue();
			}
		} catch (Throwable t) {
			if (t instanceof java.lang.Error) {
				throw (java.lang.Error) t;
			}
			if (t instanceof java.lang.RuntimeException) {
				throw (java.lang.RuntimeException) t;
			}
			throw new HammockException(t);
		}
		return super.nextInt();
	}

	public static final MockMethod MTHD_NEXT_LONG = new MockMethod(
			MockRandom.class, "MTHD_NEXT_LONG", new Class[] {}, new Class[] {},
			Long.class, false);

	public long nextLong() {
		try {
			Object[] args = new Object[0];
			MethodInvocation mi = new MethodInvocation(MTHD_NEXT_LONG, this,
					args);
			getInvocationHandler().invoke(mi);
			if (mi.isEvaluated()) {
				Object retVal = mi.getReturnValue();
				AMockObject.assertReturnNotNull(MTHD_NEXT_LONG, retVal);
				return ((Long) retVal).longValue();
			}
		} catch (Throwable t) {
			if (t instanceof java.lang.Error) {
				throw (java.lang.Error) t;
			}
			if (t instanceof java.lang.RuntimeException) {
				throw (java.lang.RuntimeException) t;
			}
			throw new HammockException(t);
		}
		return super.nextLong();
	}

	public static final MockMethod MTHD_SET_SEED_$_LONG = new MockMethod(
			MockRandom.class, "MTHD_SET_SEED_$_LONG",
			new Class[] { Long.class }, new Class[] {}, null, false);

	public void setSeed(long arg0) {
		try {
			Object[] args = new Object[1];
			args[0] = new Long(arg0);
			MethodInvocation mi = new MethodInvocation(MTHD_SET_SEED_$_LONG,
					this, args);
			getInvocationHandler().invoke(mi);
			if (mi.isEvaluated()) {
				mi.getReturnValue();
				return;
			}
		} catch (Throwable t) {
			if (t instanceof java.lang.Error) {
				throw (java.lang.Error) t;
			}
			if (t instanceof java.lang.RuntimeException) {
				throw (java.lang.RuntimeException) t;
			}
			throw new HammockException(t);
		}
		super.setSeed(arg0);
	}

	// Constructors.
	public MockRandom(long arg0) {
		super(arg0);
	}

	public MockRandom(long arg0, IInvocationHandler handler) {
		super(arg0);
		setInvocationHandler(handler);
	}

	public MockRandom() {
		super();
	}

	public MockRandom(IInvocationHandler handler) {
		super();
		setInvocationHandler(handler);
	}

}
