package com.hammingweight.hammock;

import junit.framework.TestCase;

public class DefaultArgumentMatcher11Test extends TestCase {

	// The OUT.
	private DefaultArgumentMatcher dam;
	
	public void setUp() {
		this.dam = new DefaultArgumentMatcher();
	}
	
	public void testFloatArrayCompare() {
		float[] arrayF1 = {0.1f, 0.2f, -0.3f};
		float[] arrayF2 = {0.1f, 0.2f, -0.3f};
		float[] arrayF3 = {0.1f, 0.2f};
		float[] arrayF4 = {0.1f, 0.2f, -0.3f, 0.4f};
		float[] arrayF5 = {0.1f, 0.3f, -03.f};
		
		assertTrue(this.dam.areArgumentsEqual(arrayF1, arrayF1));
		assertTrue(this.dam.areArgumentsEqual(arrayF1, arrayF2));
		assertFalse(this.dam.areArgumentsEqual(arrayF1, arrayF3));
		assertFalse(this.dam.areArgumentsEqual(arrayF1, arrayF4));
		assertFalse(this.dam.areArgumentsEqual(arrayF1, arrayF5));
	}

	public void testDoubleArrayCompare() {
		double[] arrayF1 = {0.1f, 0.2f, -0.3f};
		double[] arrayF2 = {0.1f, 0.2f, -0.3f};
		double[] arrayF3 = {0.1f, 0.2f};
		double[] arrayF4 = {0.1f, 0.2f, -0.3f, 0.4f};
		double[] arrayF5 = {0.1f, 0.3f, -03.f};
		
		assertTrue(this.dam.areArgumentsEqual(arrayF1, arrayF1));
		assertTrue(this.dam.areArgumentsEqual(arrayF1, arrayF2));
		assertFalse(this.dam.areArgumentsEqual(arrayF1, arrayF3));
		assertFalse(this.dam.areArgumentsEqual(arrayF1, arrayF4));
		assertFalse(this.dam.areArgumentsEqual(arrayF1, arrayF5));
	}
}
